from bopytex.tasks import activate_corr_on, clean, compile_pdf, generate, join_pdfs


def test_build_task_generate():
    template = "tpl_source.tex"
    task = generate(template, {"subject": "01"}, output="source.tex")
    assert task.action == "GENERATE"
    assert task.args == {"subject": "01"}
    assert task.deps == [template]


def test_build_task_activate_corr_on():
    src = "source.tex"
    task = activate_corr_on(src, output="corr_source.tex")
    assert task.action == "ACTIVATE_CORR"
    assert task.args == {}
    assert task.deps == [src]


def test_build_task_compile():
    src = "source.tex"
    task = compile_pdf(src, output="source.pdf")
    assert task.action == "COMPILE"
    assert task.args == {}
    assert task.deps == [src]


def test_build_task_join():
    pdfs = [f"{i}_source.pdf" for i in range(3)]
    task = join_pdfs(pdfs, output="joined.pdf")
    assert task.action == "JOIN"
    assert task.args == {}
    assert task.deps == pdfs


def test_build_task_clean():
    files = ["source.aux", "source.log"]
    task = clean(files)
    assert task.action == "CLEAN"
    assert task.args == {}
    assert task.deps == files
